; File Name   :	F:\hobby\rechner\Z9001\dev\drucker\r0115\V24a3_com.rom
; Base Address:	0000h Range: 0080h - 0180h Loaded length: 0100h
; ---------------------------------------------------------------------------

		cpu	z80

; Kassette R0115, Ladeprogramm fr X2XA3.COM

		org 80h

loader:		ld	hl, 005Ch	; FCB
		ld	(hl), 'X'	; Programmname Stelle 1 und 3 in 'X' ndern
		inc	hl
		inc	hl
		ld	(hl), 'X'
		ld	de, aStopTape0	; Ausgabe "Stop Tape. Run (Y/N)"
		call	prnst
loader1:	call	consi
		cp	'Y'		; mit Autostart
		jr	z, loader2
		cp	'N'		; ohne Autostart
		jr	nz, loader1
loader2:	ld	b, a
		call	outa		; Ausgabe Zeichen A
		ld	hl, 0042h	
		ld	a, (hl)		; Test,	ob Programm schon mal geladen wurde
		ld	(hl), b		; Autostart merken
		cp	'Y'
		jr	z, addr
		cp	'N'
		jr	z, addr
		inc	hl
		ld	a, (0037h)	; Hi-Byte EOR
		ld	(hl), a		; HL=0043h
addr:		ld	de, aAddress	; "\n\r\nADDRESS:"
		call	prnst
addr1:		ld	a, (0043h)	; Hi-Byte EOR
		sub	1		; bentigter Speicherplatz in 100h-Blcken (hier 1, V24A1: 4)
		ld	h, a
		ld	l, 0
		push	hl		; HL=vorgeschlagene hchstmgliche Adresse
		ld	a, 0Ah
		call	hexin		; Ladeadresse abfragen
		pop	de
		ld	a, 0
		ret	c		; bei Fehler
		cp	l
		jr	nz, addr1	; Ladeadresse zu gro
		ld	a, d
		sub	h
		jr	c, addr1	; Ladeadresse zu gro
		ld	(001Bh), hl	; Ladeadresse in DMA ablegen, fr READS
		ld	a, 0Ah
		call	outa		; Ausgabe Zeichen A
		ld	a, 0Dh
		call	outa		; Ausgabe Zeichen A
		
;Loader Teil2 laden (Vorblock + 100h Byte) nach HL und dort starten
		ld	c, 13		; OPENR
		ld	b, 3		; Anzahl zu ladende Blcke (0..2)
load:		call	5		; Block 0 lesen
		jr	nc, load1	; wenn kein Lesefehler
		push	bc
		push	hl
		call	0F5A6h		; REA1,	Warten auf Bedienerreaktion bei	Fehler
		pop	hl
		pop	bc
		ret	c
		jr	load
; ---------------------------------------------------------------------------
load1:		ld	c, 20		; READS
					; Laden	nach (DMA)
		djnz	load		; B Blcke lesen
		jp	(hl)		; Loader starten auf Ladeadresse
; ---------------------------------------------------------------------------
aStopTape0:	db  14h
		db    1
aStopTape:	db "stop tape"
		db  14h
		db    2
aRunYN:		db "\n"
		db "\r\n"
		db "RUN (Y/N): ",0
aAddress:	db "\n"
		db "\r\n"
		db "ADDRESS:",0
; ---------------------------------------------------------------------------
; Ladeadresse abfragen
hexin:		ld	c, 17		; GETCU
		call	5
		ld	e, a
hexin1:		ld	c, 18		; SETCU
		call	5
		push	de
		call	hexhl		; Ausgabe HL hexadezimal
		ld	e, 'H'
		call	conso
		pop	de
		call	consi
		sub	30h ; '0'
		cp	0Ah		; 0-9
		jr	c, hexin2
		sub	11h
		cp	6		; A-F
		jr	nc, hexin3
		add	a, 0Ah
hexin2:		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	a, l
		ld	l, a
		jr	hexin1
;
hexin3:		cp	0CCh
		ret	z
		cp	0C2h
		jr	nz, hexin1
		scf
		ret
; ---------------------------------------------------------------------------
; Ausgabe HL hexadezimal
hexhl:		ld	d, h
		call	hex1
		ld	d, l
hex1:		ld	a, d
		rrca
		rrca
		rrca
		rrca
		call	hex2
		ld	a, d
hex2:		and	0Fh
		cp	0Ah
		jr	c, hex3
		add	a, 7
hex3:		add	a, 30h ; '0'
; ---------------------------------------------------------------------------
; Ausgabe Zeichen A
outa:		ld	e, a
conso:		ld	c, 2		; CONSO
		jr	callbos
; ---------------------------------------------------------------------------
prnst:		ld	c, 9		; PRNST
		jr	callbos
; ---------------------------------------------------------------------------
consi:		ld	c, 1		; CONSI
callbos:	jp	5
; ---------------------------------------------------------------------------

		end
